#extension GL_OES_EGL_image_external : require
precision mediump float;
varying vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;

vec4 blend(vec4 Cb, vec4 Cs) {
    float CbCsAlphaProduct = Cb.a * Cs.a;

    float ra;
    if (Cs.r == 0.0) {
        ra = 0.0;
    } else {
        ra = CbCsAlphaProduct - min(CbCsAlphaProduct, (CbCsAlphaProduct * Cs.a - Cb.r * Cs.a * Cs.a) / Cs.r);
    }

    float rg;
    if (Cs.g == 0.0) {
        rg = 0.0;
    } else {
        rg = CbCsAlphaProduct - min(CbCsAlphaProduct, (CbCsAlphaProduct * Cs.a - Cb.g * Cs.a * Cs.a) / Cs.g);
    }

    float rb;
    if (Cs.b == 0.0) {
        rb = 0.0;
    } else {
        rb = CbCsAlphaProduct - min(CbCsAlphaProduct, (CbCsAlphaProduct * Cs.a - Cb.b * Cs.a * Cs.a) / Cs.b);
    }

    return vec4((1.0 - Cs.a) * Cb.rgb + (1.0 - Cb.a) * Cs.rgb + vec3(ra, rg, rb), Cb.a + Cs.a - Cb.a * Cs.a);
}

void main() {
    vec4 base =texture2D(inputImageTexture2, textureCoordinate);
    vec4 overlay =texture2D(inputImageTexture, textureCoordinate);
    gl_FragColor =blend(base,overlay);
}
