#extension GL_OES_EGL_image_external : require
precision mediump float;
varying vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform float opacity;


vec4 blend(vec4 base, vec4 overlay) {
    return vec4(max(overlay.rgb + (1.0 - overlay.a) * base.rgb, base.rgb + (1.0 - base.a) * overlay.rgb), base.a + overlay.a - base.a * overlay.a);
}


void main() {
    vec4 base =texture2D(inputImageTexture2, textureCoordinate);
    vec4 overlay =texture2D(inputImageTexture, textureCoordinate);
    gl_FragColor =blend(base,overlay);
}