#extension GL_OES_EGL_image_external : require
precision mediump float;
varying vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform float opacity;



vec4 blend(vec4 base, vec4 overlay) {
    vec3 baseRGB = base.rgb / (base.a + step(base.a, 0.0));
    vec3 overlayRGB = overlay.rgb / (overlay.a + step(overlay.a, 0.0));
    float baseSum = baseRGB.r * 0.299 + baseRGB.g * 0.587 + baseRGB.b * 0.114;
    float overlaySum = overlayRGB.r * 0.299 + overlayRGB.g * 0.587 + overlayRGB.b * 0.114;
    vec3 color = overlaySum > baseSum ? overlayRGB : baseRGB;
    return vec4((1.0 - overlay.a) * base.rgb + (1.0 - base.a) * overlay.rgb + base.a * overlay.a * color, base.a + overlay.a - base.a * overlay.a);
}


void main() {
    vec4 base =texture2D(inputImageTexture2, textureCoordinate);
    vec4 overlay =texture2D(inputImageTexture, textureCoordinate);
    gl_FragColor =blend(base,overlay);
}