precision highp float;

attribute vec3 aPos;
attribute vec2 aTexCoord;
attribute vec3 aNormal;

varying vec2 u_TexCoord;
varying vec3 u_FragPos;
varying vec3 u_Normal;

uniform mat4 model;
uniform mat4 view;
uniform mat4 perspective;

void main()
{
    u_Normal = aNormal;
    u_TexCoord = aTexCoord;
    vec4 modelPos = model * vec4(aPos, 1.0);
    u_FragPos = vec3(modelPos.xyz);
    gl_Position = perspective * view * modelPos;
}