#extension GL_OES_standard_derivatives : enable

precision highp float;

varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2; // TODO: This is not used

uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2; // mask texture

#define BASE 0.1
#define DEBUG 0

void main()
{
    highp vec4 textureColor = texture2D(inputImageTexture, textureCoordinate);
    highp vec4 textureColor2 = texture2D(inputImageTexture2, textureCoordinate);
  
    if (DEBUG == 1) {
        gl_FragColor = textureColor2.rgaa;
    } else {
        float maxV = max(max(textureColor2.r, textureColor2.g), max(textureColor2.b, textureColor2.r));
        if (maxV > BASE) {
            gl_FragColor = textureColor;
        } else {
            gl_FragColor = vec4(0.0);
        }
    }
} 