#extension GL_OES_EGL_image_external : require
precision mediump float;

varying vec2 outTexCoord;
varying vec2 outOverlayTexCoord;
uniform samplerExternalOES texture;

uniform bool enableOverlay;
uniform samplerExternalOES overlayTexture;

void main() {
    vec4 color = texture2D(texture, outTexCoord);
    if (enableOverlay) {
        vec4 overlayColor = texture2D(overlayTexture, outOverlayTexCoord);
        gl_FragColor = overlayColor + (1.0 - overlayColor.a) * color;
    } else {
        gl_FragColor = color;
    }
}