precision mediump float;

varying vec2 vTextureCoord;
uniform sampler2D uTexture;

// 采样次数
const int Samples = 64;
// 采样权重
const float startIntensity = 0.07;
// 每次采样衰减
const float Decay = 0.9;

void main() {
    float Intensity = startIntensity;
    vec2 TexCoord = vTextureCoord, Direction = vec2(0.5) - TexCoord;
    Direction /= float(Samples);
    vec3 Color = texture2D(uTexture, TexCoord).rgb;

    for (int Sample = 0; Sample < Samples; Sample++)
    {
        Color += texture2D(uTexture, TexCoord).rgb * Intensity;
        Intensity *= Decay;
        TexCoord += Direction;
    }
    gl_FragColor = vec4(Color, 1.0);
}